<template>
    <div
        v-if="pageReady && plan"
        class="w-full"
    >
        <div
            class="w-full bg-neutral text-white flex justify-between items-center py-3"
        >
            <div class="w-12 cursor-pointer pl-4">
                <font-awesome-icon
                    icon="fa-solid fa-arrow-left"
                    size="2x"
                    @click="$router.go(-1)"
                />
            </div>
            <div class="flex-1 text-center">
                <a
                    href="javascript:"
                    class="cursor-pointer"
                    @click="$router.push({name: 'user.home'})"
                >
                    <img
                        :src="'/img/logo.png'"
                        class="h-12 mx-auto text-center"
                    />
                </a>
            </div>
            <div class="w-12" />
        </div>
        <div
            class="mb-20 relative z-0"
        >
            <img
                :src="plan.featured_photo"
                class="aspect-video object-cover"
            />
        </div>
        <template
            v-if="plan"
        >
            <div
                class="relative mx-8 my-6 flex flex-col space-y-2 -mt-36 z-1"
            >
                <div
                    class="w-full shadow-lg rounded-xl bg-white shadow-lg shadow-gray-300 px-2 py-4"
                >
                    <div
                        class="flex justify-start space-x-2 border-b border-gray-300 pb-6 mb-6"
                    >
                        <div
                            class="flex-1"
                        >
                            <div>
                                <div class="font-black leading-tight text-lg">{{ plan.plan_name }}</div>
                                <div class="font-bold leading-tight text-xs mb-2">({{ plan.code }})</div>
                            </div>
                            <div
                                class="flex justify-between capitalize items-center"
                            >
                                <div
                                    class="flex-1 flex justify-start space-x-3 items-center"
                                >
                                    <div>
                                        {{ $t(`plan_${plan.setting.plan_type}_category`)}}
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div
                        class="flex justify-between"
                    >
                        <div
                            class="flex-1 font-black flex justify-start items-center text-xl"
                        >
                            <span
                                v-if="plan.return_percentage_from > 0"
                                class="text-green-500 text-2xl "
                            >
                                +{{ plan.return_percentage_from }}%
                            </span>
                            <span
                                v-else-if="plan.return_percentage_from < 0"
                                class="text-red-600 text-2xl font-black"
                            >
                                {{ plan.return_percentage_from }}%
                            </span>
                            <span
                                class="px-2"
                            >
                                to
                            </span>
                            <span
                                v-if="plan.return_percentage_to > 0"
                                class="text-green-500 text-2xl "
                            >
                                +{{ plan.return_percentage_to }}%
                            </span>
                            <span
                                v-else-if="plan.return_percentage_to < 0"
                                class="text-red-600 text-2xl font-black"
                            >
                                {{ plan.return_percentage_to }}%
                            </span>
                        </div>
                    </div>
                </div>
            </div>
        </template>
        <div
            class="px-3 w-full lg:max-w-[400px] lg:text-center lg:mx-auto grid grid-cols-2 gap-2 mt-4"
        >
            <div
                class="rounded-xl bg-white shadow-lg shadow-gray-300 grid-cols-1 flex flex-col px-2 py-4"
            >
                <div
                    class="flex justify-start space-x-3"
                >
                    <div>
                        <img
                            :src="'/img/portfolio/buy-in-amount.png'"
                            class="w-8"
                        />
                    </div>
                    <div
                        class="flex flex-col justify-start items-start"
                    >
                        <div
                            class="text-[10px] font-bold mb-1 leading-tight capitalize"
                        >
                            {{ $t('buy_in_amount')}}
                        </div>
                        <div
                            class="font-black"
                        >
                            {{ $helper.fundFormat(investment.total_invest) }}
                        </div>
                    </div>
                </div>
            </div>
            <div
                class="rounded-xl bg-white shadow-lg shadow-gray-300 grid-cols-1 flex flex-col px-2 py-4"
            >
                <div
                    class="flex justify-start space-x-3"
                >
                    <div>
                        <img
                            :src="'/img/portfolio/contract-period.png'"
                            class="w-8"
                        />
                    </div>
                    <div
                        class="flex flex-col justify-start items-start"
                    >
                        <div
                            class="text-[10px] font-bold mb-1 leading-tight capitalize"
                        >
                            {{ $t('contract_period')}}
                        </div>
                        <div
                            class="font-black text-[11px]"
                        >
                            <div>
                                {{ investment.contract_start }}
                            </div>
                            <div>
                                {{ investment.contract_end }}
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div
                class="rounded-xl bg-white shadow-lg shadow-gray-300 grid-cols-1 flex flex-col px-2 py-4"
            >
                <div
                    class="flex justify-start space-x-3"
                >
                    <div>
                        <img
                            :src="'/img/portfolio/money-icon.png'"
                            class="w-8"
                        />
                    </div>
                    <div
                        class="flex flex-col justify-start items-start"
                    >
                        <div
                            class="text-[10px] font-bold mb-1 leading-tight capitalize"
                        >
                            <template
                                v-if="investment.plan_type === 'structured'"
                            >
                                {{ $t('total_realized_roi') }} ($)
                            </template>
                            <template
                                v-else-if="investment.plan_type === 'assured'"
                            >
                                {{ $t('total_unrealized_roi') }} ($)
                            </template>
                        </div>
                        <div
                            class="font-black text-xs"
                        >
                            $ {{ $helper.fundFormat(investment.total_roi) }}
                        </div>
                    </div>
                </div>
            </div>
            <div
                class="rounded-xl bg-white shadow-lg shadow-gray-300 grid-cols-1 flex flex-col px-2 py-4"
            >
                <div
                    class="flex justify-start space-x-3"
                >
                    <div>
                        <img
                            :src="'/img/portfolio/money-icon.png'"
                            class="w-8"
                        />
                    </div>
                    <div
                        class="flex flex-col justify-start items-start"
                    >
                        <div
                            class="text-[10px] font-bold mb-1 leading-tight capitalize"
                        >
                            <template
                                v-if="investment.plan_type === 'structured'"
                            >
                                {{ $t('total_realized_roi') }} (%)
                            </template>
                            <template
                                v-else-if="investment.plan_type === 'assured'"
                            >
                                {{ $t('total_unrealized_roi') }} (%)
                            </template>
                        </div>
                        <div
                            class="font-black text-xs"
                        >
                            {{ $helper.fundFormat((investment.total_roi / investment.total_invest) * 100) }} %
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div
            class="py-6 w-full lg:max-w-[400px] lg:mx-auto"
        >
            <div class="pl-2 font-black">
                <template
                    v-if="investment.plan_type === 'structured'"
                >
                    {{ $t('realized_return_on_investment_records') }}
                </template>
                <template
                    v-else-if="investment.plan_type === 'assured'"
                >
                    {{ $t('unrealized_return_on_investment_records') }}
                </template>
            </div>
            <div
                class="py-4 px-3 flex flex-col justify-start space-y-3"
            >
                <div
                    v-for="transaction in transactions"
                    :key="`tx-${transaction.id}`"
                    class="bg-white p-2 rounded-lg shadow shadow-gray-300"
                >
                    <div
                        class="flex justify-between space-x-2 mb-2 items-center capitalize"
                    >
                        <div>{{ $t('roi_declare_date_time') }}</div>
                        <div class="font-black">{{ transaction.created_at }}</div>
                    </div>
                    <template
                        v-if="transaction.roi_percentage > 0"
                    >
                        <div
                            class="flex justify-between space-x-2 mb-2 items-center capitalize"
                        >
                            <div>{{ $t('trade_result') }}</div>
                            <div
                                class="font-black text-green-600"
                            >
                                {{ $t('profit') }}
                            </div>
                        </div>
                        <div
                            class="flex justify-between space-x-2 mb-2 items-center capitalize"
                        >
                            <div>{{ $t(transaction.plan_type === 'structured' ? 'realized_roi' : 'unrealized_roi') }}</div>
                            <div
                                class="font-black text-green-600"
                            >
                                $ {{ $helper.fundFormat(transaction.amount) }} ({{ transaction.roi_percentage }}%)
                            </div>
                        </div>
                    </template>
                    <template
                        v-else
                    >
                        <div
                            class="flex justify-between space-x-2 mb-2 items-center capitalize"
                        >
                            <div>{{ $t('trade_result') }}</div>
                            <div
                                class="font-black text-red-600"
                            >
                                {{ $t('loss') }}
                            </div>
                        </div>
                        <div
                            class="flex justify-between space-x-2 mb-2 items-center capitalize"
                        >
                            <div>{{ $t(transaction.plan_type === 'structured' ? 'realized_roi' : 'unrealized_roi') }}</div>
                            <div
                                class="font-black text-red-600"
                            >
                                $ {{ $helper.fundFormat(transaction.amount) }} ({{ transaction.roi_percentage }}%)
                            </div>
                        </div>
                    </template>
                </div>
            </div>
        </div>
    </div>
</template>

<script setup>
import {ref, computed, onMounted} from "vue";
import axios from "axios";
import {useRoute, useRouter} from "vue-router";
import {useSettingStore} from "~/stores/setting.js";
import moment from "moment";
import BigNumber from "bignumber.js";

const $settingStore = useSettingStore();
const $route = useRoute();
const $router = useRouter();
const pageReady = ref(false);
const existingInvestments = ref({});
const existingInvestmentHistories = ref({});

const plan = computed(() => {
    if (!$route.params.code) return null;
    return $settingStore.settings.plans.find(r => {
        return String(r.code).toUpperCase() === String($route.params.code).toUpperCase();
    });
});

const investment = computed(() => {
    if (!existingInvestments.value) return null;
    if (!plan.value) return null;
    let i = existingInvestments.value[plan.value.code];

    let obj = {
        ...plan.value,
        plan_type: plan.value.setting.plan_type,
        contract_start: String(plan.value).toUpperCase() === 'AASF' ? '2020-11-01 00:00:00' : '2018-11-01 00:00:00',
        contract_end: String(plan.value).toUpperCase() === 'AASF' ? '2022-11-01 00:00:00' : '2022-11-01 00:00:00',
    };

    obj.total_invest = i;
    obj.total_roi = 0;

    if (typeof existingInvestmentHistories.value[plan.value.code] !== 'undefined') {
        Object.keys(existingInvestmentHistories.value[plan.value.code]).forEach(key => {
            obj.total_roi += (obj.total_invest / 100) * existingInvestmentHistories.value[plan.value.code][key];
        });

        obj.win_loss_percentage = (obj.total_roi / obj.total_invest) * 100;
    }

    return obj;
});

const transactions = computed(() => {
    if (!existingInvestments.value) return null;
    if (!plan.value) return null;
    if (!investment.value) return null;

    if (typeof existingInvestmentHistories.value[plan.value.code] === 'undefined') return null;

    let arr = [];
    Object.keys(existingInvestmentHistories.value[plan.value.code]).forEach(key => {
        arr.push({
            ...plan.value,
            plan_type: plan.value.setting.plan_type,
            roi_percentage: existingInvestmentHistories.value[plan.value.code][key],
            amount: new BigNumber(investment.value.total_invest).div(100).times(existingInvestmentHistories.value[plan.value.code][key]).toNumber(),
            created_at: key + ' 03:00:00',
        });
    });
    return arr;
})

onMounted(async () => {
    try {
        const data = await axios.post('/portfolio/fetch/existing');
        if (data.investments) {
            existingInvestments.value = data.investments;
        }
        if (data.histories) {
            existingInvestmentHistories.value = data.histories;
        }

        pageReady.value = true;
    } catch (e) {
        console.log(e);
    }
});
</script>
